## jskeus 1.2.4+dfsg

=== Makefile ===
all: eus-installed irteus-installed manuals bashrc.eus

GIT_EUSURL ?= http://github.com/euslisp/EusLisp
GIT_EUSBRANCH ?= master

EUSC_PATCH=eus.c_CUSTUM_EUSDIR.patch

GCC_MACHINE=$(shell gcc -dumpmachine)
$(info "-- GCC_MACHINE = ${GCC_MACHINE}")
ifneq ($(GCC_MACHINE),)
 ifeq ($(GCC_MACHINE),x86_64-linux-gnu)
   MACHINE=x86_64
 endif
 ifeq ($(GCC_MACHINE),i686-linux-gnu)
   MACHINE=x86
 endif
endif
ifeq ($(MACHINE),)
 MACHINE=$(shell uname -m)
endif
OS=$(shell uname -s | sed 's/[^A-Za-z1-9].*//')
$(info "-- MACHINE = ${MACHINE}")
$(info "--      OS = ${OS}")
ifeq ($(OS),Linux)
 ifeq ($(MACHINE),x86_64)
  export ARCHDIR=Linux64
  export MAKEFILE=Makefile.Linux64
 else
 ifneq (, $(findstring armv,$(MACHINE)))
  export ARCHDIR=LinuxARM
  export MAKEFILE=Makefile.LinuxARM
 else ifneq (, $(findstring aarch,$(MACHINE)))
  export ARCHDIR=LinuxARM
  export MAKEFILE=Makefile.LinuxARM
 else
  export ARCHDIR=Linux
  export MAKEFILE=Makefile.Linux.thread
 endif
 endif
endif
ifeq ($(OS),CYGWIN)
 export ARCHDIR=Cygwin
 export MAKEFILE=Makefile.Cygwin
endif
ifeq ($(OS),Darwin)
 export ARCHDIR=Darwin
 export MAKEFILE=Makefile.Darwin
endif

export EUSDIR=$(shell pwd)/eus

manuals: manual.pdf jmanual.pdf
manual.pdf:
	ln -sf eus/doc/latex/manual.pdf manual.pdf

jmanual.pdf:
	ln -sf eus/doc/jlatex/jmanual.pdf  jmanual.pdf

bashrc.eus:
	@bash -c 'echo -e "#\n\
# bashrc.eus : environment variable for euslisp \n#\n\
export EUSDIR=$(EUSDIR) \n\
export ARCHDIR=$(ARCHDIR) \n\
export PATH=\$$EUSDIR/\$$ARCHDIR/bin:\$$EUSDIR/\$$ARCHDIR/lib:\$$PATH \n\
export LD_LIBRARY_PATH=\$$EUSDIR/\$$ARCHDIR/lib:\$$EUSDIR/\$$ARCHDIR/bin:\$$LD_LIBRARY_PATH \n\
"' > bashrc.eus
	@bash -c 'echo -e "\e[1;32m;; generating bashrc.eus ...\n;;\e[m"'
	@bash -c 'echo -e "\e[1;32m;;   mv bashrc.eus ~/bashrc.eus\e[m"'
	@bash -c 'echo -e "\e[1;32m;;   echo \"source ~/bashrc.eus\" >> ~/.bashrc\e[m"'
	@bash -c 'echo -e "\e[1;32m;;   source ~/.bashrc\e[m"'
	@cat bashrc.eus

eus:
	COUNT=10; while [ $$COUNT -gt 0 -a ! -e eus ] ; do echo $$COUNT; sleep 1; GIT_SSL_NO_VERIFY=true git clone --depth 10 $(GIT_EUSURL) -b $(GIT_EUSBRANCH) eus; COUNT=`expr $$COUNT - 1`; done; #

eus-installed: eus
	cd eus/lisp && ln -sf $(MAKEFILE) Makefile && $(MAKE) eus0 eus1 eus2 eusg eusx eusgl eus

irteus-installed: eus-installed
	cd irteus; $(MAKE)

clean:
	-rm -f bashrc.eus manual.pdf jmanual.pdf
	if [ -e irteus ]; then cd irteus; make clean ; fi
	if [ -e eus/lisp ]; then cd eus/lisp; make clean ; fi

wipe: clean
	-rm -fr eus irteus


doc:
	cd doc; make

.PHONY: doc

=== doc/Makefile ===
TMPDIR := $(shell mktemp -d)
FIGDIR := ${TMPDIR}/fig

# IMAGE_FILES := $(shell find ${FIGDIR} -name "*.(jpg|png)" | sed s/jpg/bb/g)

# BB_FILES = $(patsubst %.jpg,%.bb,$(IMAGE_FILES))

# .SUFFIXES: .txt .tex .bbl .bb .jpg .JPG .png .PNG .bmp .BMP .pdf

# .jpg.bb:
# 	ebb -b $<

all: pdf
	rm -fr ${TMPDIR}

copy_eus_tex:
	-mkdir -p ${TMPDIR}/fig
	cp ../eus/doc/jlatex/*.tex ${TMPDIR}
	cp ../eus/doc/jlatex/*.sty ${TMPDIR}
	cp -r ../eus/doc/jlatex/fig/* ./fig/* ${TMPDIR}/fig/
	(cd ${TMPDIR};for x in fig/*.ps;  do ps2ps $$x $$x.new; mv $$x.new $$x; done) ### ???? we need to run ps2ps to pass gs??
	(cd ${TMPDIR};for x in fig/*.jpg; do extractbb $$x; done) # workaround for https://github.com/backtracking/bibtex2html/issues/9
	cp *.tex ${TMPDIR}
	platex --version | grep utf8 || nkf --in-place -e ${TMPDIR}/*.tex
	for x in irtrobot irtmodel irtsensor irtscene irtdyna irtgeo irtgl irtutil irtviewer irtx irtmath irtbvh irtcollada irtgraph irtimage irtpointcloud png irtcollision pqp bullet; do\
		irteusgl ../eus/lib/llib/documentation.l "(make-document \"../irteus/$$x.l\" \"${TMPDIR}/$$x-func.tex\")" "(exit)"; \
        done

current.tex:
	echo "% CURRENT_TAG" > ${TMPDIR}/current.tex
	echo "\\\\newcommand{\\\\eusversion}[0]{"`cd ../eus; git describe --tags $$(git rev-list --tags --max-count=1) | sed s/EusLisp-//`"}" >> ${TMPDIR}/current.tex
	echo "\\\\newcommand{\\\\irteusversion}[0]{"`git describe --tags $$(git rev-list --tags --max-count=1)`"}" >> ${TMPDIR}/current.tex
	cat ${TMPDIR}/current.tex

toc: copy_eus_tex current.tex
	(cd ${TMPDIR}; makeindex jmanual.tex)

dvi: toc
	(cd ${TMPDIR}; platex jmanual.tex)
	(cd ${TMPDIR}; platex jmanual.tex)
	cp ${TMPDIR}/*.dvi .

pdf: dvi
	(cd ${TMPDIR}; dvipdfmx jmanual.dvi)
	cp ${TMPDIR}/*.pdf .


clean:
	rm -f *~ *.aux *.idx *.log *.toc *.out *.ind *.ilg

distclean: clean
	rm -f *.dvi *.pdf

html: dvi
	mkdir -p ${TMPDIR}/html
	(cd ${TMPDIR}; TRANSPARENT_COLOR="#ffffff" charset="UTF-8" latex2html -dir ${TMPDIR}/html -local_icons -split +3 -auto_prefix -init_file ${PWD}/../eus/doc/latex/.latex2html-init -iso_language JP -address "This document was generated using the LaTeX2HTML translator on `date` from <a href=\"http://github.com/euslisp/jskeus.git\">jskeus</a> version <a href=\"http://github.com/euslisp/jskeus/commit/`git -C ${PWD} rev-parse --verify HEAD`\">`git log -1  --oneline`</a>" -html_version="4.0,unicode" jmanual)
	(cd ${TMPDIR}/html; for imgfile in jmanual-img*.png; do pngtopnm $$imgfile > /tmp/$$imgfile.pnm; pnmtopng -transparent white /tmp/$$imgfile.pnm > $$imgfile || echo "Failed to convert $$imgfile"; done)
	(cd ${TMPDIR}/html; sed -i 's@</TITLE>@</TITLE>\n<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">@' j*.html index.html)
	cp -r ${TMPDIR}/html ./

latex.py:
	wget https://raw.githubusercontent.com/jobh/latex.py/master/latex.py

rst: current.tex copy_eus_tex latex.py
	cp latex.py ../eus/doc/latex/preamble.tex ${TMPDIR}
	for file in ${TMPDIR}/*.tex; do \
	   name=`basename $$file .tex`; \
	   if [ \"$$name\" = \"test\" -o \"$$name\" = \"jmanual\" ]; then continue; fi; \
	   echo \"Converting $$name.tex to $$name.rst\"; \
	   (cd ${TMPDIR}; python3 latex.py -2 -L preamble.tex $$name.tex > /tmp/tmp_$$name.tex); \
	   pandoc /tmp/tmp_$$name.tex -o $$name.rst -V documentclass=ltjarticle --latex-engine=lualatex; \
	   sed -i 's@.. figure:: \(.*\).ps@.. figure:: \1.png@g' $$name.rst;  # use png for figures \
	done
	for file in ../eus/doc/jlatex/fig/*.ps; do \
	   name=`basename $$file .ps`; \
	   echo \"Converting $$name.ps to $$name.png\";  ### ???? we need to run ps2ps to pass gs?? does not happy with pstopnm \
	   pstopnm -stdout ../eus/doc/jlatex/fig/$$name.ps | pnmflip -rotate270 | pnmtopng - > fig/$$name.png; \
	done
	cp jmanual.tex /tmp/jmanual.tex
	sed -i 's@\\input{\(.*\)}@..include:: \1\n@g' /tmp/jmanual.tex     ### convert \input in tex to bypass pandoc EXCEPT current
	sed -i '/..include:: current/r ${TMPDIR}/current.tex' /tmp/jmanual.tex  ### convert \input in tex to bypass pandoc EXCEPT current
	sed -i 's@\\part{\(.*\)}@.. toctree:: \1@' /tmp/jmanual.tex  # convert \part in tex to bypass pandoc
	sed -i ':a;/^[^%].*\\\\$$/{N;s/\\\\\n//;ba}' /tmp/jmanual.tex # concatinate title/author multi lines
	sed -i '/^\\vspace{10mm}$$/d' /tmp/jmanual.tex # remove vspace{10mm} within title to pass pandoc
	pandoc --no-wrap -s /tmp/jmanual.tex -o jmanual.rst -V documentclass=ltjarticle --latex-engine=lualatex
	sed -i 's@..include:: \(.*\)@   \1@' jmanual.rst # restore ..include for rst
	sed -i 's@.. toctree:: \(.*\)@.. toctree::\n   :maxdepth: 2\n   :caption: \1@' jmanual.rst  # restore ..toctree for rst
	sed -i 's@\*\* \*\*@\*\*\n\*\*@g' jmanual.rst # add newline after ** ** in title
	sed -i 's@** -\(.*\)$$@**\n\n-\1\n@' jmanual.rst # add newline before -ロボットモデリングの拡張 in title
	sed -i -ne '3!{p;d;};h;n;p;g;p' jmanual.rst  ## swap 2nd and 3rd line
	sed -i -ne '4!{p;d;};h;n;:1;7!{N;b1};G;h;n;p;g;p' jmanual.rst  ## swap lines https://www.unix.com/shell-programming-and-scripting/85230-swapping-switching-2-lines-using-sed.html
	sed -i -ne '2h;2!H;$${g;s/\n/ /;p}' jmanual.rst  ## concatenate EusLisp and Reference Manual (https://unix.stackexchange.com/questions/188264/want-to-substitute-only-first-occurence-with-sed)
	sed -i 's/^:Author:/:Authors: -/' jmanual.rst # use :authors: insteqad of :author:
	sed -ie '/^:Authors:/ {p;s/.*//;N; s/\n/\ \ \ \ \ \ \ \ \ \ -\ /;}' jmanual.rst # add authors after :authors:
	head -n 20 jmanual.rst

=== irteus/Makefile ===
###############################################################################
###
### $Id$
###
### Copyright (c) 1987- JSK, The University of Tokyo.  All Rights Reserved.
###
### This software is a collection of EusLisp code for robot applications,
### which has been developed by the JSK Laboratory for the IRT project.
### For more information on EusLisp and its application to the robotics,
### please refer to the following papers.
###
### Toshihiro Matsui
### Multithread object-oriented language euslisp for parallel and
###  asynchronous programming in robotics
### Workshop on Concurrent Object-based Systems,
###  IEEE 6th Symposium on Parallel and Distributed Processing, 1994
###
### Redistribution and use in source and binary forms, with or without
### modification, are permitted provided that the following conditions are met:
###
### * Redistributions of source code must retain the above copyright notice,
###   this list of conditions and the following disclaimer.
### * Redistributions in binary form must reproduce the above copyright notice,
###   this list of conditions and the following disclaimer in the documentation
###   and/or other materials provided with the distribution.
### * Neither the name of JSK Robotics Laboratory, The University of Tokyo
###   (JSK) nor the names of its contributors may be used to endorse or promote
###   products derived from this software without specific prior written
###   permission.
###
### THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
### AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
### THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
### PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
### CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
### EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
### PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
### OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
### WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
### OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
### ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
###

include ./Makefile.$(ARCHDIR)

# directory where this package install object file to
IRTEUSDIR=$(EUSDIR)
INSTALLBINDIR=$(IRTEUSDIR)/$(ARCHDIR)/bin
INSTALLOBJDIR=$(IRTEUSDIR)/$(ARCHDIR)/obj
INSTALLLIBDIR=$(IRTEUSDIR)/$(ARCHDIR)/lib

# check bullet version
BULLET_VER_MAJOR:=$(shell pkg-config bullet --modversion --silence-errors | cut -f1 -d.)
BULLET_VER_MINOR:=$(shell pkg-config bullet --modversion --silence-errors | cut -f2 -d.)
ifneq ($(and $(BULLET_VER_MAJOR),$(BULLET_VER_MINOR)),)
  BULLET_GE_2_83=$(shell [ $(BULLET_VER_MAJOR) -gt 2 -o \( $(BULLET_VER_MAJOR) -eq 2 -a $(BULLET_VER_MINOR) -ge 83 \) ] && echo true)
endif
ifeq ($(BULLET_GE_2_83), true)
    HAVE_BULLET=1
else
    HAVE_BULLET=0
endif
$(info "--      HAVE_BULLET = ${HAVE_BULLET}")

ifneq ($(wildcard PQP/*),)
    HAVE_PQP=1
else
    HAVE_PQP=0
endif
$(info "--      HAVE_PQP = ${HAVE_PQP}")

# common
WFLAGS= #-Wall

BINDIR=$(EUSDIR)/$(ARCHDIR)/bin
OBJDIR=$(EUSDIR)/$(ARCHDIR)/obj
LIBDIR=$(EUSDIR)/$(ARCHDIR)/lib

ifeq ($(HAVE_PQP), 1)
  PQPCFLAGS=-DHAVE_PQP=$(HAVE_PQP)
  PQPLIBDIR=PQP/$(ARCHDIR)
  PQPLIB=-L$(PQPLIBDIR) -lPQP-static
  PQPLIBSTATIC=PQP/$(ARCHDIR)/libPQP-static.a
endif

ifeq ($(HAVE_BULLET), 1)
  BULLETCFLAGS=`pkg-config bullet --cflags` -DHAVE_BULLET=$(HAVE_BULLET)
  BULLETLIB=`pkg-config bullet --libs`
endif

MODULES.L=irt_modules.l
EUSLIB_MODULES.L=$(addprefix $(EUSDIR)/lib/,$(MODULES.L))

IRTEUS=irtmath irtutil irtgraph pgsql time
IRTEUSG=irtgeo pqp bullet irtcollision irtscene irtmodel irtsensor irtdyna irtrobot irtbvh irtcollada irtpointcloud irtstl irtwrl
IRTEUSX=irtx
IRTEUSIMG=irtimage eusjpeg png
IRTEUSGL=irtgl irtglrgb irtviewer
NR=nr

LIBIRTEUS=$(INSTALLLIBDIR)/$(LPFX)irteus.$(LSFX)
LIBIRTEUSG=$(INSTALLLIBDIR)/$(LPFX)irteusg.$(LSFX)
LIBIRTEUSX=$(INSTALLLIBDIR)/$(LPFX)irteusx.$(LSFX)
LIBIRTEUSIMG=$(INSTALLLIBDIR)/$(LPFX)irteusimg.$(LSFX)
LIBIRTEUSGL=$(INSTALLLIBDIR)/$(LPFX)irteusgl.$(LSFX)
LIBNR=$(INSTALLLIBDIR)/$(LPFX)nr.$(LSFX)

IRTEUS_OSFX=$(addsuffix .$(OSFX),$(IRTEUS))
IRTEUS_LSFX=$(addsuffix .$(LSFX),$(IRTEUS))
IRTEUSOBJS=$(addprefix $(INSTALLOBJDIR)/,$(IRTEUS_OSFX))
IRTEUSDLLS=$(addprefix $(INSTALLOBJDIR)/,$(IRTEUS_LSFX))
IRTEUS_C=$(addprefix $(INSTALLOBJDIR)/,$(addsuffix .c,$(IRTEUS)))
IRTEUS_H=$(addprefix $(INSTALLOBJDIR)/,$(addsuffix .h,$(IRTEUS)))
IRTEUS_L=$(addsuffix .l,$(IRTEUS))
IRTEUS_L:=$(subst pgsql.l,$(EUSDIR)/lib/llib/pgsql.l,$(IRTEUS_L))
IRTEUS_L:=$(subst time.l,$(EUSDIR)/lib/llib/time.l,$(IRTEUS_L))

IRTEUSG_OSFX=$(addsuffix .$(OSFX),$(IRTEUSG))
IRTEUSG_LSFX=$(addsuffix .$(LSFX),$(IRTEUSG))
IRTEUSGOBJS=$(addprefix $(INSTALLOBJDIR)/,$(IRTEUSG_OSFX))
IRTEUSGDLLS=$(addprefix $(INSTALLOBJDIR)/,$(IRTEUSG_LSFX))
IRTEUSG_C=$(addprefix $(INSTALLOBJDIR)/,$(addsuffix .c,$(IRTEUSG)))
IRTEUSG_H=$(addprefix $(INSTALLOBJDIR)/,$(addsuffix .h,$(IRTEUSG)))
IRTEUSG_L=$(addsuffix .l,$(IRTEUSG))

IRTEUSX_OSFX=$(addsuffix .$(OSFX),$(IRTEUSX))
IRTEUSX_LSFX=$(addsuffix .$(LSFX),$(IRTEUSX))
IRTEUSXOBJS=$(addprefix $(INSTALLOBJDIR)/,$(IRTEUSX_OSFX))
IRTEUSXDLLS=$(addprefix $(INSTALLOBJDIR)/,$(IRTEUSX_LSFX))
IRTEUSX_C=$(addprefix $(INSTALLOBJDIR)/,$(addsuffix .c,$(IRTEUSX)))
IRTEUSX_H=$(addprefix $(INSTALLOBJDIR)/,$(addsuffix .h,$(IRTEUSX)))
IRTEUSX_L=$(addsuffix .l,$(IRTEUSX))

IRTEUSIMG_OSFX=$(addsuffix .$(OSFX),$(IRTEUSIMG))
IRTEUSIMG_LSFX=$(addsuffix .$(LSFX),$(IRTEUSIMG))
IRTEUSIMGOBJS=$(addprefix $(INSTALLOBJDIR)/,$(IRTEUSIMG_OSFX))
IRTEUSIMGDLLS=$(addprefix $(INSTALLOBJDIR)/,$(IRTEUSIMG_LSFX))
IRTEUSIMG_C=$(addprefix $(INSTALLOBJDIR)/,$(addsuffix .c,$(IRTEUSIMG)))
IRTEUSIMG_H=$(addprefix $(INSTALLOBJDIR)/,$(addsuffix .h,$(IRTEUSIMG)))
IRTEUSIMG_L=$(patsubst eusjpeg.l,$(EUSDIR)/lisp/image/jpeg/eusjpeg.l,$(addsuffix .l,$(IRTEUSIMG)))

IRTEUSGL_OSFX=$(addsuffix .$(OSFX),$(IRTEUSGL))
IRTEUSGL_LSFX=$(addsuffix .$(LSFX),$(IRTEUSGL))
IRTEUSGLOBJS=$(addprefix $(INSTALLOBJDIR)/,$(IRTEUSGL_OSFX))
IRTEUSGLDLLS=$(addprefix $(INSTALLOBJDIR)/,$(IRTEUSGL_LSFX))
IRTEUSGL_C=$(addprefix $(INSTALLOBJDIR)/,$(addsuffix .c,$(IRTEUSGL)))
IRTEUSGL_H=$(addprefix $(INSTALLOBJDIR)/,$(addsuffix .h,$(IRTEUSGL)))
IRTEUSGL_L=$(addsuffix .l,$(IRTEUSGL))

IRTCOBJECTS=$(INSTALLOBJDIR)/irtc.$(OSFX) $(INSTALLOBJDIR)/irtgeoc.$(OSFX)
IRTGCOBJECTS=$(INSTALLOBJDIR)/CPQP.$(OSFX) $(INSTALLOBJDIR)/euspqp.$(OSFX) $(INSTALLOBJDIR)/CBULLET.$(OSFX) $(INSTALLOBJDIR)/eusbullet.$(OSFX)
IRTIMGCOBJECTS=$(INSTALLOBJDIR)/euspng.$(OSFX)
IRTGLCOBJECTS=$(INSTALLOBJDIR)/irtglc.$(OSFX)
NROBJECTS=$(INSTALLOBJDIR)/nr.$(OSFX)

all: defun.h $(LIBNR) $(LIBIRTEUS) $(LIBIRTEUSG) $(LIBIRTEUSX) $(LIBIRTEUSIMG) $(LIBIRTEUSGL) make-link install-irtext.l

.PHONY: defun.h
defun.h:
	echo '#include "eus.h"\n#undef defun\npointer TEST();\nvoid test(void) {register context *ctx; pointer mod; defun(ctx,"TEST",mod,TEST,NULL);}' > test.c
	echo "// redefine defun for update defun() API () https://github.com/euslisp/EusLisp/pull/116" > defun.h
	echo "#undef defun" >> defun.h
	$(CC) $(CFLAGS) $(WFLAGS) -c test.c $(OBJOPT) test.o || echo "#define defun(a, b, c, d, e) defun(a, b, c, d) // for EusLisp < 9.24" >> defun.h
	cat defun.h

$(LIBIRTEUS): $(IRTEUSOBJS) $(IRTCOBJECTS) $(LIBNR)
	$(LD) $(SOFLAGS) $(OUTOPT)$(LIBIRTEUS) $(IRTEUSOBJS) \
		$(IRTCOBJECTS) $(IMPLIB)

$(LIBIRTEUSG): $(IRTEUSGOBJS) $(IRTGCOBJECTS) $(LIBNR)
	$(LD) $(SOFLAGS) $(OUTOPT)$(LIBIRTEUSG) $(IRTEUSGOBJS) \
		$(IRTGCOBJECTS) $(IMPLIB) $(PQPLIB) $(BULLETLIB)

$(LIBIRTEUSX): $(IRTEUSXOBJS) $(LIBNR)
	$(LD) $(SOFLAGS) $(OUTOPT)$(LIBIRTEUSX) $(IRTEUSXOBJS) $(IMPLIB)

$(LIBIRTEUSIMG): $(INSTALLLIBDIR)/jpegmemcd.$(LSFX) $(IRTEUSIMGOBJS) $(IRTIMGCOBJECTS) $(LIBNR)
	$(LD) $(SOFLAGS) $(OUTOPT)$(LIBIRTEUSIMG) $(IRTEUSIMGOBJS) $(IRTIMGCOBJECTS) $(IMPLIB) $(IMPLIBIMG)

$(LIBIRTEUSGL): $(IRTEUSGLOBJS) $(IRTGLCOBJECTS) $(LIBNR)
	$(LD) $(SOFLAGS) $(OUTOPT)$(LIBIRTEUSGL) $(IRTEUSGLOBJS) $(IRTGLCOBJECTS) $(IMPLIB)

$(IRTEUSOBJS): $(INSTALLOBJDIR)/compile_irt.log
$(IRTEUSOBJS) $(INSTALLOBJDIR)/compile_irt.log: $(IRTEUS_L)
	$(BINDIR)/eus2$(ESFX) "(setq *objdir* \"$(INSTALLOBJDIR)/\")" < ./compile_irt.l > $(INSTALLOBJDIR)/compile_irt.log
	-rm -f $(IRTEUS_C) $(IRTEUS_H)

$(IRTEUSGOBJS): $(INSTALLOBJDIR)/compile_irtg.log
$(IRTEUSGOBJS) $(INSTALLOBJDIR)/compile_irtg.log: $(IRTEUSG_L)
	$(BINDIR)/eusgl$(ESFX) "(setq *objdir* \"$(INSTALLOBJDIR)/\")" < ./compile_irtg.l > $(INSTALLOBJDIR)/compile_irtg.log
	-rm -f $(IRTEUSG_C) $(IRTEUSG_H)

$(IRTEUSXOBJS): $(INSTALLOBJDIR)/compile_irtx.log
$(IRTEUSXOBJS) $(INSTALLOBJDIR)/compile_irtx.log: $(IRTEUSX_L)
	$(BINDIR)/eusx$(ESFX) "(setq *objdir* \"$(INSTALLOBJDIR)/\")" < ./compile_irtx.l > $(INSTALLOBJDIR)/compile_irtx.log
	-rm -f $(IRTEUSX_C) $(IRTEUSX_H)

$(IRTEUSIMGOBJS): $(INSTALLOBJDIR)/compile_irtimg.log
$(IRTEUSIMGOBJS) $(INSTALLOBJDIR)/compile_irtimg.log: $(IRTEUSIMG_L)
	$(BINDIR)/eusx$(ESFX) "(setq *objdir* \"$(INSTALLOBJDIR)/\")" < ./compile_irtimg.l > $(INSTALLOBJDIR)/compile_irtimg.log
	-rm -f $(IRTEUSIMG_C) $(IRTEUSIMG_H)

$(IRTEUSGLOBJS): $(INSTALLOBJDIR)/compile_irtgl.log
$(IRTEUSGLOBJS) $(INSTALLOBJDIR)/compile_irtgl.log: $(IRTEUSGL_L)
	$(BINDIR)/eusgl$(ESFX) "(setq *objdir* \"$(INSTALLOBJDIR)/\")" < ./compile_irtgl.l > $(INSTALLOBJDIR)/compile_irtgl.log
	-rm -f $(IRTEUSGL_C) $(IRTEUSGL_H)

PQP/$(ARCHDIR)/libPQP-static.a:
	make -C PQP

$(LIBNR): $(NROBJECTS)
	$(LD) $(SOFLAGS) $(OUTOPT)$(LIBNR) $(NROBJECTS)

BINS=$(BINDIR)/irteus$(ESFX) $(BINDIR)/irteusgl$(ESFX)
make-link: $(BINS) $(EUSDIR)/irteus
$(BINS):
	(cd $(INSTALLBINDIR); ln -sf eus$(ESFX) irteus$(ESFX))
	(cd $(INSTALLBINDIR); ln -sf eusgl$(ESFX) irteusgl$(ESFX))
$(EUSDIR)/irteus:
	(cd $(IRTEUSDIR); ln -sf ../irteus irteus)

install-irtext.l: $(IRTEUSDIR)/lib/irtext.l
$(IRTEUSDIR)/lib/irtext.l: irtext.l
	-cp -f irtext.l $(IRTEUSDIR)/lib

clean:
	-rm -f $(IRTCOBJECTS) $(IRTGCOBJECTS)
	-rm -f $(LIBIRTEUS) $(LIBIRTEUSG) $(LIBIRTEUSGL) $(LIBIRTEUSX) $(LIBIRTEUSIMG)
	-rm -f $(IRTEUSOBJS) $(IRTEUSDLLS) $(IRTEUS_C) $(IRTEUS_H)
	-rm -f $(IRTEUSGOBJS) $(IRTEUSGDLLS) $(IRTEUSG_C) $(IRTEUSG_H)
	-rm -f $(IRTEUSXOBJS) $(IRTEUSXDLLS) $(IRTEUSX_C) $(IRTEUSX_H)
	-rm -f $(IRTEUSIMGOBJS) $(IRTEUSIMGDLLS) $(IRTEUSIMG_C) $(IRTEUSIMG_H)
	-rm -f $(IRTEUSGLOBJS) $(IRTEUSGLDLLS) $(IRTEUSGL_C) $(IRTEUSGL_H)
	-rm -f $(INSTALLLIBDIR)/jpegmemcd.$(LSFX) $(LIBNR) $(NROBJECTS)
	-rm -f *~ *.stackdump
	-rm -f $(EUSDIR)/irteus
	-rm -f $(INSTALLOBJDIR)/compile_*.log
	chmod a-x Makefile* *.l *.c
	[ -e PQP ] && (cd PQP;make clean)
	if [ -w $(EUSDIR)/lisp/image/jpeg/ ]; then make -C $(EUSDIR)/lisp/image/jpeg/ clean; else echo "EUSDIR/lisp/image/jpeg/ is not writable"; fi
	-rm -f $(EUSDIR)/lib/llib/pgsql.c $(EUSDIR)/lib/llib/pgsql.h
	-rm -f $(EUSDIR)/lib/llib/time.c $(EUSDIR)/lib/llib/time.h

$(INSTALLOBJDIR)/irtmath.$(OSFX): irtmath.l
$(INSTALLOBJDIR)/irtutil.$(OSFX): irtutil.l
$(INSTALLOBJDIR)/irtgraph.$(OSFX): irtgraph.l
$(INSTALLOBJDIR)/irtgeo.$(OSFX): irtgeo.l
$(INSTALLOBJDIR)/irtscene.$(OSFX): irtscene.l
$(INSTALLOBJDIR)/irtmodel.$(OSFX): irtmodel.l
$(INSTALLOBJDIR)/irtdyna.$(OSFX): irtdyna.l
$(INSTALLOBJDIR)/irtcollada.$(OSFX): irtcollada.l
$(INSTALLOBJDIR)/irtstl.$(OSFX): irtstl.l
$(INSTALLOBJDIR)/irtwrl.$(OSFX): irtwrl.l
$(INSTALLOBJDIR)/irtsensor.$(OSFX): irtsensor.l
$(INSTALLOBJDIR)/irtpointcloud.$(OSFX): irtpointcloud.l
$(INSTALLOBJDIR)/irtrobot.$(OSFX): irtrobot.l
$(INSTALLOBJDIR)/irtbvh.$(OSFX): irtbvh.l
$(INSTALLOBJDIR)/irtx.$(OSFX): irtx.l
$(INSTALLOBJDIR)/irtgl.$(OSFX): irtgl.l
$(INSTALLOBJDIR)/irtglrgb.$(OSFX): irtglrgb.l
$(INSTALLOBJDIR)/irtviewer.$(OSFX): irtviewer.l
$(INSTALLOBJDIR)/irtimage.$(OSFX): irtimage.l
$(INSTALLOBJDIR)/irtcollision.$(OSFX): irtcollision.l
$(INSTALLOBJDIR)/pqp.$(OSFX): pqp.l
$(INSTALLOBJDIR)/bullet.$(OSFX): bullet.l
$(INSTALLOBJDIR)/png.$(OSFX): png.l
$(INSTALLOBJDIR)/pgsql.$(OSFX): $(EUSDIR)/lib/llib/pgsql.l
$(INSTALLOBJDIR)/time.$(OSFX): $(EUSDIR)/lib/llib/time.l

=== debian/changelog ===
jskeus (1.2.4+dfsg-3) unstable; urgency=medium

  * fix reproducible bug (Closes: #966179)

 -- Kei Okada <kei.okada@gmail.com>  Mon, 21 Dec 2020 02:35:48 +0000

jskeus (1.2.4+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Source only upload

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 20 Jul 2020 13:35:52 +0200

jskeus (1.2.4+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #960845)

 -- Kei Okada <kei.okada@gmail.com>  Sat, 16 May 2020 03:21:02 +0000

=== debian/control ===
Source: jskeus
Section: lisp
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Kei Okada <kei.okada@gmail.com>
Build-Depends: debhelper-compat (=13), libgl1-mesa-dev, libglu1-mesa-dev, libjpeg-dev, libpng-dev, libpq-dev, libx11-dev, libxext-dev, pkg-config, libbullet-dev, euslisp-dev
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/euslisp/jskeus
Vcs-Git: https://salsa.debian.org/science-team/jskeus.git
Vcs-Browser: https://salsa.debian.org/science-team/jskeus

Package: jskeus
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}, libbullet-dev, euslisp
Suggests: jskeus-doc
Description: Lisp based intelligent robots programming system
 jskeus contains software developed and used by JSK at The University
 of Tokyo. This provides modeling classes for sensors, actuators and
 robot body as well as kinematics and dynamics function library for
 writing intelligent robot behaviors. It also contains graph data
 strucutre, point cloud data class, Bullet collision detection, BVH
 character animation, STL/WRL/DAE reader and writer and some
 extensions to EusLisp language
 .
 This package contains the irteus/irteusgl executable and accompanying
 demo files.
 
Package: jskeus-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, euslisp-dev, jskeus
Description: Development files of Lisp based  intelligent robots programming system
 jskeus-dev provides C language headers and C and Lisp source files
 for developping jskeus based modulse.
 .
 This package contains *eusdir*/jskeus/{*.l, *.c, *.h, test}

Package: jskeus-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Manuals and Documentations of jskeus programming system
 jskeus-doc contains various README and pdf version of manual of
 jskeus as known as jmanual. This also includes EusLisp manual.
 .
 This package contains the documentation of jskeus

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

execute_before_dh_auto_configure:
	sed -i s/@@DEB_HOST_MULTIARCH@@/${DEB_HOST_MULTIARCH}/ $(CURDIR)/irteus/irtext.l

## jskeus 1.2.6+dfsg

=== irteus/Makefile ===
--- 
+++ 
@@ -88,10 +88,12 @@
   BULLETLIB=`pkg-config bullet --libs`
 endif
 
+PNG_CFLAGS=`pkg-config libpng --cflags`
+
 MODULES.L=irt_modules.l
 EUSLIB_MODULES.L=$(addprefix $(EUSDIR)/lib/,$(MODULES.L))
 
-IRTEUS=irtmath irtutil irtgraph pgsql time
+IRTEUS=irtmath irtutil irtgraph gnuplotlib pgsql time
 IRTEUSG=irtgeo pqp bullet irtcollision irtscene irtmodel irtsensor irtdyna irtrobot irtbvh irtcollada irtpointcloud irtstl irtwrl
 IRTEUSX=irtx
 IRTEUSIMG=irtimage eusjpeg png
@@ -261,8 +263,7 @@
 $(INSTALLOBJDIR)/irtviewer.$(OSFX): irtviewer.l
 $(INSTALLOBJDIR)/irtimage.$(OSFX): irtimage.l
 $(INSTALLOBJDIR)/irtcollision.$(OSFX): irtcollision.l
+$(INSTALLOBJDIR)/gnuplotlib.$(OSFX): gnuplotlib.l
 $(INSTALLOBJDIR)/pqp.$(OSFX): pqp.l
 $(INSTALLOBJDIR)/bullet.$(OSFX): bullet.l
 $(INSTALLOBJDIR)/png.$(OSFX): png.l
-$(INSTALLOBJDIR)/pgsql.$(OSFX): $(EUSDIR)/lib/llib/pgsql.l
-$(INSTALLOBJDIR)/time.$(OSFX): $(EUSDIR)/lib/llib/time.l

=== debian/changelog ===
jskeus (1.2.6+dfsg-2) unstable; urgency=medium

  * Team upload.
  [ Adrian Bunk ]
  * Build with -std=gnu17 to workaround FTBFS with GCC 15.
    Closes: #1096878.
  [ Santiago Vila ]
  * Update lintian overrides.
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Mon, 22 Sep 2025 20:20:00 +0200

jskeus (1.2.6+dfsg-1) unstable; urgency=medium

  * New upstream version 1.2.6+dfsg
   #1069313 causes .c file installed via euslisp-dev,
    which is resolved in EusLisp-9.30
   see https://github.com/euslisp/EusLisp/pull/509
   (Closes: #1069313)
   update debian/patches/fix-make-clean.patch for #1048840
   (Closes: #1048840)

 -- Kei Okada <kei.okada@gmail.com>  Tue, 17 Dec 2024 11:23:32 +0900

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -std=gnu17

%:
	dh $@

execute_before_dh_auto_configure:
	sed -i.orig s/@@DEB_HOST_MULTIARCH@@/${DEB_HOST_MULTIARCH}/ $(CURDIR)/irteus/irtext.l

execute_before_dh_clean:
	mv  $(CURDIR)/irteus/irtext.l.orig  $(CURDIR)/irteus/irtext.l || true

## jskeus 1.2.7%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Kei Okada <kei.okada@gmail.com>
-Build-Depends: debhelper-compat (=13), libgl1-mesa-dev, libglu1-mesa-dev, libjpeg-dev, libpng-dev, libpq-dev, libx11-dev, libxext-dev, pkg-config, libbullet-dev, euslisp-dev
+Build-Depends: debhelper-compat (=13), libgl-dev, libglu1-mesa-dev, libjpeg-dev, libpng-dev, libpq-dev, libx11-dev, libxext-dev, pkgconf, libbullet-dev, euslisp-dev
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/euslisp/jskeus
 Vcs-Git: https://salsa.debian.org/science-team/jskeus.git
 Vcs-Browser: https://salsa.debian.org/science-team/jskeus

## jskeus 1.2.7+dfsg

=== Makefile ===
--- 
+++ 
@@ -14,6 +14,12 @@
  ifeq ($(GCC_MACHINE),i686-linux-gnu)
    MACHINE=x86
  endif
+ ifeq ($(GCC_MACHINE),aarch64-linux-gnu)
+   MACHINE=aarch64
+ endif
+ ifeq ($(GCC_MACHINE),arm-linux-gnueabihf)
+   MACHINE=arm
+ endif
 endif
 ifeq ($(MACHINE),)
  MACHINE=$(shell uname -m)
@@ -26,7 +32,7 @@
   export ARCHDIR=Linux64
   export MAKEFILE=Makefile.Linux64
  else
- ifneq (, $(findstring armv,$(MACHINE)))
+ ifneq (, $(findstring arm,$(MACHINE)))
   export ARCHDIR=LinuxARM
   export MAKEFILE=Makefile.LinuxARM
  else ifneq (, $(findstring aarch,$(MACHINE)))

=== doc/Makefile ===
--- 
+++ 
@@ -22,7 +22,7 @@
 	(cd ${TMPDIR};for x in fig/*.jpg; do extractbb $$x; done) # workaround for https://github.com/backtracking/bibtex2html/issues/9
 	cp *.tex ${TMPDIR}
 	platex --version | grep utf8 || nkf --in-place -e ${TMPDIR}/*.tex
-	for x in irtrobot irtmodel irtsensor irtscene irtdyna irtgeo irtgl irtutil irtviewer irtx irtmath irtbvh irtcollada irtgraph irtimage irtpointcloud png irtcollision pqp bullet; do\
+	for x in irtrobot irtmodel irtsensor irtscene irtdyna irtgeo irtgl irtutil irtviewer irtx irtmath irtbvh irtcollada irtgraph gnuplotlib irtimage irtpointcloud png irtcollision pqp bullet; do\
 		irteusgl ../eus/lib/llib/documentation.l "(make-document \"../irteus/$$x.l\" \"${TMPDIR}/$$x-func.tex\")" "(exit)"; \
         done

=== irteus/Makefile ===
--- 
+++ 
@@ -159,7 +159,7 @@
 
 .PHONY: defun.h
 defun.h:
-	echo '#include "eus.h"\n#undef defun\npointer TEST();\nvoid test(void) {register context *ctx; pointer mod; defun(ctx,"TEST",mod,TEST,NULL);}' > test.c
+	echo '#include "eus.h"\n#undef defun\npointer TEST();\nvoid test(void) {register context *ctx; pointer mod; defun((context *)ctx,(char *)"TEST",(pointer)mod,(pointer(*)(context*,int,pointer*))TEST,(char *)NULL);}' > test.c
 	echo "// redefine defun for update defun() API () https://github.com/euslisp/EusLisp/pull/116" > defun.h
 	echo "#undef defun" >> defun.h
 	$(CC) $(CFLAGS) $(WFLAGS) -c test.c $(OBJOPT) test.o || echo "#define defun(a, b, c, d, e) defun(a, b, c, d) // for EusLisp < 9.24" >> defun.h
@@ -266,4 +266,3 @@
 $(INSTALLOBJDIR)/gnuplotlib.$(OSFX): gnuplotlib.l
 $(INSTALLOBJDIR)/pqp.$(OSFX): pqp.l
 $(INSTALLOBJDIR)/bullet.$(OSFX): bullet.l
-$(INSTALLOBJDIR)/png.$(OSFX): png.l

=== debian/changelog ===
jskeus (1.2.7+dfsg-2) unstable; urgency=medium

  * Revert "Build with -std=gnu17 to workaround FTBFS with GCC 15. Closes: #1096878."

 -- Kei Okada <kei.okada@gmail.com>  Wed, 01 Oct 2025 09:49:10 +0900

jskeus (1.2.7+dfsg-1) unstable; urgency=medium

  [ Kei ]
  * New upstream version 1.2.7+dfsg
  update prototype definition for gcc-15
  (Closes: #1096878)
  update debian/patches for jskeus 1.2.7
  (see https://github.com/euslisp/jskeus/pull/650)

 -- Kei Okada <kei.okada@gmail.com>  Tue, 23 Sep 2025 17:29:58 +0900

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,6 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_CFLAGS_MAINT_APPEND = -std=gnu17
 
 %:
 	dh $@

=== debian/tests/control ===
Tests: jskeus-test
Depends: jskeus, shunit2

Tests: jskeus-all-test
Depends: @, shunit2

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%jskeus-$1.tar.gz%,repacksuffix=+dfsg,dversionmangle=s/\+dfsg//" \
    https://github.com/euslisp/jskeus/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
